function [ ] = OUTPUT( Global )
%OUTPUT Function to write all calculated values to a textfile
%   Takes all calculated values from TDAT and save them with the name
%   stated by the user.

fileID = fopen(Global.Output,'w');

fprintf(fileID,'%20s %30s \n',['Ouput file for ',Global.file_name]);
fprintf(fileID,'\n');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.3f %8s \n','Rig radius =  ',Global.r,'[m]');
fprintf(fileID,'%20s %12.3f %8s \n','Rig height =  ',Global.h,'[m]');
fprintf(fileID,'%20s %12.4f %8s \n','Rig volume =  ',Global.V,'[m^3]');
fprintf(fileID,'%20s %12.4f %8s \n','Rig area =  ',Global.A,'[m^2]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.4f %8s \n','x_CO =  ',Global.xCOgas,'[-]');
fprintf(fileID,'%20s %12.4f %8s \n','x_H2 =  ',Global.xH2gas,'[-]');
fprintf(fileID,'%20s %12.4f %8s \n','x_N2 =  ',Global.xN2gas,'[-]');
fprintf(fileID,'%20s %12.4f %8s \n','x_O2 =  ',Global.xO2gas,'[-]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.2f %8s \n','R_gas = ',Global.Rgas,'[J/kgK]');
fprintf(fileID,'%20s %12.3f %8s \n','p_rig = ',Global.p0/1e5,'[bar]');
fprintf(fileID,'\n');
fprintf(fileID,'%19s %12.4f %7s \n','m_gas = ',Global.mgas, '[kg]');
fprintf(fileID,'%19s %12.4f %7s \n','m_CO = ',Global.mCOmix, '[kg]');
fprintf(fileID,'%19s %12.4f %7s \n','m_H2 = ',Global.mH2mix, '[kg]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.4f %8s \n','Hn_CO =  ',...
    Global.hn_CO/1e6, '[MJ/kg]');
fprintf(fileID,'%20s %12.4f %8s \n','Hn_H2 =  ',...
    Global.hn_H2/1e6, '[MJ/kg]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.1f %8s \n','Q_CO =  ',Global.Q_CO/1000, '[kJ]');
fprintf(fileID,'%20s %12.1f %8s \n','Q_H2 =  ',Global.Q_H2/1000, '[kJ]');
fprintf(fileID,'%20s %12.1f %8s \n','Q_tot =  ',Global.Q_tot/1000, '[kJ]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.1f %8s \n','Q_pre-comb =  ',...
    Global.Q_pre_combustion/1000, '[kJ]');
fprintf(fileID,'%20s %12.1f %8s \n','Q_fuel =  ',...
    Global.Q_injection/1000, '[kJ]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.4f %8s \n','m_air =  ',Global.mair, '[kg]');
fprintf(fileID,'%20s %12.4f %8s \n','m_O2_air =  ',Global.mO2air, '[kg]');
fprintf(fileID,'%20s %12.4f %8s \n','m_N2_air =  ',Global.mN2air, '[kg]');
fprintf(fileID,'%20s %12.4f %8s \n','m_rig =  ',Global.mrig, '[kg]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.4f %8s \n','m_O2_mix =  ',Global.mO2mix, '[kg]');
fprintf(fileID,'%20s %12.4f %8s \n','m_N2_mix =  ',Global.mN2mix, '[kg]');
fprintf(fileID,'%20s %12.4f %8s \n','m_CO_mix =  ',Global.mCOmix, '[kg]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.4f %8s \n','xCO_mix =  ',Global.xCOmix, '[-]');
fprintf(fileID,'%20s %12.4f %8s \n','xN2_mix =  ',Global.xN2mix, '[-]');
fprintf(fileID,'%20s %12.4f %8s \n','xO2_mix =  ',Global.xO2mix, '[-]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.2f %8s \n','R_mix =  ',Global.Rmix, '[J/kgK]');
fprintf(fileID,'%20s %12.2f %8s \n','M_mix =  ',Global.Mmix, '[g/mol]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.4f %8s \n','eta_comb =  ',...
    Global.eta_comb(end)*100, '[%]');
fprintf(fileID,'%20s %12.4f %8s \n','T_diff =  ',...
    Global.T_diff(end), '[K]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.4f %8s \n','xCO_burned =  ',Global.xCOp, '[-]');
fprintf(fileID,'%20s %12.4f %8s \n','xCO2_burned =  ',Global.xCO2p, '[-]');
fprintf(fileID,'%20s %12.4f %8s \n','xO2_burned =  ',Global.xO2p, '[-]');
fprintf(fileID,'%20s %12.4f %8s \n','xN2_burned =  ',Global.xN2p, '[-]');
fprintf(fileID,'\n');
fprintf(fileID,'%20s %12.2f %8s \n','R_burned =  ',...
    Global.Rburned, '[J/kgK]');
fprintf(fileID,'%20s %12.1f %8s \n','Injection time =  ',...
    Global.injection_time, '[s]');

fclose(fileID);

end

