function varargout = TDAT(varargin)
%TDAT M-file for TDAT.fig
%      TDAT, by itself, creates a new TDAT or raises the existing
%      singleton*.
%
%      H = TDAT returns the handle to a new TDAT or the handle to
%      the existing singleton*.
%
%      TDAT('Property','Value',...) creates a new TDAT using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to TDAT_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      TDAT('CALLBACK') and TDAT('CALLBACK',hObject,...) call the
%      local function named CALLBACK in TDAT.M with the given input
%      arguments.
%
%      *See TDAT Options on GUIDE's Tools menu.  Choose "TDAT allows only 
%       one instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TDAT

% Last Modified by GUIDE v2.5 02-Jun-2014 19:19:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TDAT_OpeningFcn, ...
                   'gui_OutputFcn',  @TDAT_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before TDAT is made visible.
function TDAT_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for TDAT
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TDAT wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TDAT_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

clc

set(handles.Calculations_box, 'string','')

% Clear previous plots
cla(handles.pre_combustion)
axes(handles.pre_combustion)
title('ROHR pre-combustion','Fontname','Times',...
    'FontWeight','bold','FontSize',16)
legend(handles.pre_combustion,'hide')
xlabel('Time from ignition [s]','FontSize',12,'Fontname','Times')
ylabel('dQdt [kJ/s]','FontSize',12,'Fontname','Times')

cla(handles.injection)
axes(handles.injection)
title('ROHR experiment','FontWeight','bold',...
    'FontName','Times','FontSize',16);
legend(handles.injection,'hide')
xlabel('Time from injection [ms]','FontName','Times','FontSize',12);
ylabel('dQdt [kJ/s]','FontName','Times','FontSize',12);

% Clear values displays
set(handles.Injection_temp, 'string','[C]')
set(handles.Injection_pressure, 'string','[bar]')
set(handles.Mass_in_rig, 'string','[kg]')
set(handles.Burn_time_1, 'string', '[ms]')
set(handles.Burn_time_2, 'string', '[ms]')
set(handles.Burn_time_3, 'string', '[ms]')

% Import name of input and output file
Global.file_name = get(handles.File_name_input,'String');
Global.Output = get(handles.Output,'String');

% Import mass fractions of gas
Global.xCOgas = str2double(get(handles.CO_gas_value,'String'))/100;
Global.xH2gas = str2double(get(handles.H2_gas_value,'String'))/100;
Global.xN2gas = str2double(get(handles.N2_gas_value,'String'))/100;
Global.xO2gas = str2double(get(handles.O2_gas_value,'String'))/100;

% Import volume fractions of air
Global.yN2air = str2double(get(handles.N2_air_value,'String'))/100;
Global.yO2air = str2double(get(handles.O2_air_value,'String'))/100;

% Import mass of fuel burned values
Global.MFB1 = str2double(get(handles.Mass_fuel_burned_1,'String'))/100;
Global.MFB2 = str2double(get(handles.Mass_fuel_burned_2,'String'))/100;
Global.MFB3 = str2double(get(handles.Mass_fuel_burned_3,'String'))/100;

% Control the sum of mass and volume fractions
control_gas = Global.xCOgas + Global.xH2gas ...
    + Global.xN2gas + Global.xO2gas;

control_air = Global.yN2air + Global.yO2air;

% Round off the sum to four digits
control_gas = str2double(sprintf('%.4f',control_gas));

control_air = str2double(sprintf('%.4f',control_air));


% Check if the input values are in the 
if control_gas==1 && control_air==1
    
    set(handles.Calculations_box, 'string','Computing')
    
    pause(2)

    [ Global ] = RUN(Global);
    
    % Set the injection pressure to display the overpressure
    Injection_pressure = Global.p_injection/1e5 - 1; % [bar]
    
    % Set the injection temperature to display in degrees C
    Injection_temperature = Global.T_injection - 273.15; % [C]
   
    set(handles.Injection_temp, 'string',...
        [num2str(Injection_temperature,4) ' [C]'])
    set(handles.Injection_pressure, 'string',...
        [num2str(Injection_pressure,5) ' [bar]'])
    set(handles.Mass_in_rig, 'string',[num2str(Global.mrig,3) ' [kg]'])
    
    set(handles.Burn_time_1, 'string', ...
        [num2str(Global.MFB_time_1_smooth,3) ' [ms]'])
    set(handles.Burn_time_2, 'string', ...
        [num2str(Global.MFB_time_2_smooth,3) ' [ms]'])
    set(handles.Burn_time_3, 'string', ...
        [num2str(Global.MFB_time_3_smooth,3) ' [ms]'])

    axes(handles.pre_combustion)
    plot(Global.time_two_zones,Global.ROHR_pre_combustion/1e3,...
    Global.time_two_zones,Global.ROHR_pre_combustion_numeric/1e3)
    title('ROHR pre-combustion','FontWeight','bold',...
        'FontName','Times','FontSize',16)
    legend('ROHR fitted', 'ROHR dp numeric');
    xlabel('Time from ignition [s]','FontName','Times','FontSize',12)
    ylabel('dQdt [kJ/s]','FontName','Times','FontSize',12)
    axis tight

    axes(handles.injection)
    % Creating an horizontal line in ROHR = 0
    line = [Global.time_injection(1)*1000,Global.time_injection(end)*1000];
    plot(Global.time_injection.*1000,Global.ROHR_injection_numeric/1e3,...
        Global.time_injection.*1000,Global.ROHR_injection_smooth/1e3,...
        line,[0 0],'k')
    title('ROHR experiment','FontName','Times',...
        'FontWeight','bold','FontSize',16)
    legend('Numerical fit','Smooth')
    xlabel('Time from injection [ms]','FontName','Times','FontSize',12)
    ylabel('dQdt [kJ/s]','FontName','Times','FontSize',12)
    axis tight

    set(handles.Calculations_box, 'string','Finished')
elseif control_air==1
    set(handles.Calculations_box, 'string','Check gas composition')
elseif control_gas==1
    set(handles.Calculations_box, 'string','Check air composition')
else
    set(handles.Calculations_box, 'string','Check both air and gas composition')
end
    
    
% load handel.mat
% 
% filename = 'handel.flac';
% audiowrite(filename,y,Fs);
% 
% samples = [1,2*Fs];
% clear y Fs
% [y,Fs] = audioread(filename,samples);
% 
% sound(y,Fs);

pause(180)

set(handles.Calculations_box, 'string','')


function File_name_input_Callback(hObject, eventdata, handles)
% hObject    handle to File_name_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of File_name_input as text
%        str2double(get(hObject,'String')) returns contents of File_name_input as a double


% --- Executes during object creation, after setting all properties.
function File_name_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to File_name_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Output_Callback(hObject, eventdata, handles)
% hObject    handle to Output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Output as text
%        str2double(get(hObject,'String')) returns contents of Output as a double


% --- Executes during object creation, after setting all properties.
function Output_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function H2_gas_value_Callback(hObject, eventdata, handles)
% hObject    handle to H2_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of H2_gas_value as text
%        str2double(get(hObject,'String')) returns contents of H2_gas_value as a double


% --- Executes during object creation, after setting all properties.
function H2_gas_value_CreateFcn(hObject, eventdata, handles)
% hObject    handle to H2_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function CO_gas_value_Callback(hObject, eventdata, handles)
% hObject    handle to CO_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of CO_gas_value as text
%        str2double(get(hObject,'String')) returns contents of CO_gas_value as a double


% --- Executes during object creation, after setting all properties.
function CO_gas_value_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CO_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function O2_gas_value_Callback(hObject, eventdata, handles)
% hObject    handle to O2_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of O2_gas_value as text
%        str2double(get(hObject,'String')) returns contents of O2_gas_value as a double


% --- Executes during object creation, after setting all properties.
function O2_gas_value_CreateFcn(hObject, eventdata, handles)
% hObject    handle to O2_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function N2_gas_value_Callback(hObject, eventdata, handles)
% hObject    handle to N2_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of N2_gas_value as text
%        str2double(get(hObject,'String')) returns contents of N2_gas_value as a double


% --- Executes during object creation, after setting all properties.
function N2_gas_value_CreateFcn(hObject, eventdata, handles)
% hObject    handle to N2_gas_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Mass_fuel_burned_1_Callback(hObject, eventdata, handles)
% hObject    handle to Mass_fuel_burned_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Mass_fuel_burned_1 as text
%        str2double(get(hObject,'String')) returns contents of Mass_fuel_burned_1 as a double


% --- Executes during object creation, after setting all properties.
function Mass_fuel_burned_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Mass_fuel_burned_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Mass_fuel_burned_2_Callback(hObject, eventdata, handles)
% hObject    handle to Mass_fuel_burned_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Mass_fuel_burned_2 as text
%        str2double(get(hObject,'String')) returns contents of Mass_fuel_burned_2 as a double


% --- Executes during object creation, after setting all properties.
function Mass_fuel_burned_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Mass_fuel_burned_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Mass_fuel_burned_3_Callback(hObject, eventdata, handles)
% hObject    handle to Mass_fuel_burned_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Mass_fuel_burned_3 as text
%        str2double(get(hObject,'String')) returns contents of Mass_fuel_burned_3 as a double


% --- Executes during object creation, after setting all properties.
function Mass_fuel_burned_3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Mass_fuel_burned_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function O2_air_value_Callback(hObject, eventdata, handles)
% hObject    handle to O2_air_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of O2_air_value as text
%        str2double(get(hObject,'String')) returns contents of O2_air_value as a double


% --- Executes during object creation, after setting all properties.
function O2_air_value_CreateFcn(hObject, eventdata, handles)
% hObject    handle to O2_air_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function N2_air_value_Callback(hObject, eventdata, handles)
% hObject    handle to N2_air_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of N2_air_value as text
%        str2double(get(hObject,'String')) returns contents of N2_air_value as a double


% --- Executes during object creation, after setting all properties.
function N2_air_value_CreateFcn(hObject, eventdata, handles)
% hObject    handle to N2_air_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
